﻿DeclareModule Spectr

Structure SpectrData
  Arr.f[256]
EndStructure


Declare Init()
Declare Deinit()
Declare SendData(*Data.SpectrData)
EndDeclareModule

Module Spectr

EnableExplicit

#USB_VID = $1610
#USB_PID = $2016

Structure SendStruct
  Report.a
  SendArray.u[15]
  Reserved.u
EndStructure

Global g_hThread=0, g_BreakThread=#False
Global USB_hDevice


Procedure Thread(*x)
  Protected Old_Test=-1
  Protected Test
  
  Repeat
  
    Test=HID::TestDevice(#USB_PID, #USB_VID)
    If Test<>Old_Test
      Old_Test=Test
      If Test 
        HID::CloseDevice(USB_hDevice) : USB_hDevice = 0
        USB_hDevice=HID::OpenDevice(#USB_PID, #USB_VID)
      Else
        HID::CloseDevice(USB_hDevice)
        USB_hDevice=0
      EndIf
    EndIf
    
    Delay(400)
    
  Until g_BreakThread=#True
  
EndProcedure

Procedure SendDevice(Array Z.f(1))
  Protected Buff.SendStruct
  Protected i
  
  Buff\Report = 0
  
  For i=0 To 14
    Buff\SendArray[i] = Z(i)
  Next i
  
  If USB_hDevice
    HID::WriteDevice(USB_hDevice, @Buff, SizeOf(SendStruct))
  EndIf
  
EndProcedure


Macro ChannelData(Start, Ends, Num)
  For i = Start To Ends
    TempF = *Data\Arr[i]
    If Z(Num) < TempF
      Z(Num) = TempF
    EndIf
  Next i
EndMacro

Procedure GetSpectr(*Data.SpectrData)
 
  Protected i, TempF.f
  Protected Dim Z.f(14)
  
  
  ChannelData(0, 2, 0)
  ChannelData(3, 5, 1)
  ChannelData(6, 9, 2)
  ChannelData(9, 11, 3)
  ChannelData(12, 18, 4)
  ChannelData(19, 24, 5)
  ChannelData(25, 38, 6)
  ChannelData(39, 47, 7)
  ChannelData(48, 63, 8)
  ChannelData(64, 80, 9)
  ChannelData(81, 100, 10)
  ChannelData(101, 130, 11)
  ChannelData(131, 180, 12)
  ChannelData(181, 200, 13)
  ChannelData(201, 255, 14)
  
  For i=0 To 14
    Z(i)=Z(i)/100
    Z(i)=4095*Pow(Z(i),1/2) ;компрессируем и вычитаем уровень шума
    If Z(i)>4095 : Z(i)=4095
    ElseIf Z(i)<0 : Z(i)=0 : EndIf
  Next
  
  ;PrintN(StrF(*Data\Arr[10])+"    "+StrF(Z(3)))
  
  
  SendDevice(Z())
  
EndProcedure

Procedure SendData(*Data.SpectrData)
  If *Data And USB_hDevice
    GetSpectr(*Data)
  EndIf
EndProcedure

Procedure Init()
  ;OpenConsole()
  g_hThread = CreateThread(@Thread(), 0)
EndProcedure

Procedure Deinit()
  g_BreakThread=#True
EndProcedure

EndModule
; IDE Options = PureBasic 5.44 LTS (Windows - x86)
; CursorPosition = 104
; FirstLine = 78
; Folding = --
; EnableUnicode
; EnableXP
; CompileSourceDirectory