﻿DeclareModule Visual

UseModule AIMP
UseModule Unknown

Declare Create(*Core.IAIMPCore)
Declare Free(*This)
EndDeclareModule

Module Visual

Structure Visual Extends UnkSctuct
  *Core.IAIMPCore
  Width.u
  Height.u
EndStructure

EnableExplicit

Macro SizeScr()
  If Width>0 And Width<=4000 And
     Height>0 And Height<=4000
    
    *This\Width = Width
    *This\Height = Height
    
    Res = #S_OK
  EndIf
EndMacro

Procedure GetFlags(*This.Visual)
  ProcedureReturn #AIMP_VISUAL_FLAGS_RQD_DATA_SPECTRUM
EndProcedure

Procedure GetMaxDisplaySize(*This.Visual, *Width.Integer, *Height.Integer)
  Protected Res = #E_FAIL
  
  If *This And *Width And *Height
    *Width\i = 4000
    *Height\i = 4000
    Res = #S_OK
  EndIf
  
  ProcedureReturn Res
EndProcedure

Procedure GetName(*This.Visual, *S.Integer)
  Protected Name.s="Тест"
  Protected *Str.IAIMPString, Res = #E_FAIL
  
  *This\Core\CreateObject(?__IID_IAIMPString, @*Str)
  
  If *Str
    *Str\SetData(Name, Len(Name))
    *S\i = *Str
    Res = #S_OK
  EndIf
  
  ProcedureReturn Res
  
  DataSection
    __IID_IAIMPString:
    Data.l $41494D50
    Data.u $5374, $7269
    Data.a $6E, $67, $00, $00, $00, $00, $00, $00
  EndDataSection
EndProcedure

Procedure Initialize(*This.Visual, Width, Height)
  Protected Res = #E_FAIL
  
  SizeScr()
  
  If Res = #S_OK
    If Spectr::Init(Width, Height) = 0
      Res = #E_FAIL
    EndIf
  EndIf
  
  ProcedureReturn Res
EndProcedure

Procedure Finalize(*This.Visual)
  Spectr::Free()
EndProcedure

Procedure Click(*This.Visual, X, Y, Button)
  
EndProcedure

Procedure Draw(*This.Visual, DC, *Data.TAIMPVisualData)
  Spectr::Drawing(DC, @*Data\Spectrum[2]\Arr[0])
EndProcedure

Procedure Resize(*This.Visual, Width, Height)
  Protected Res = #E_FAIL
  
  SizeScr()
  If Res = #S_OK
    Spectr::Resize(Width, Height)
  EndIf
  
  ProcedureReturn Res
EndProcedure

Procedure Create(*Core.IAIMPCore)
  Protected *Struct.Visual
  
  *Struct = AllocateMemory(SizeOf(Visual))
  If *Struct
    InitializeStructure(*Struct, Visual)
    ;CopyMemory(AIMP::?IID_IAIMPExtensionEmbeddedVisualization, @*Struct\IID, SizeOf(GUID))
    CopyMemory(?__IID_IAIMPExtensionEmbeddedVisualization, @*Struct\IID, SizeOf(GUID))
    *Struct\Core = *Core
    *Struct\VT = ?Proc
  EndIf
  
  ProcedureReturn *Struct
  
  DataSection
    Proc:
    Unknown::UnkProc
    Data.i @GetFlags()
    Data.i @GetMaxDisplaySize()
    Data.i @GetName()
    Data.i @Initialize()
    Data.i @Finalize()
    Data.i @Click()
    Data.i @Draw()
    Data.i @Resize()
    
    __IID_IAIMPExtensionEmbeddedVisualization:
    Data.l $41494D50
    Data.u $4578, $7445
    Data.a $6D, $62, $64, $56, $69, $73, $00, $00
    
  EndDataSection
EndProcedure

Procedure Free(*This.Visual)
  Protected Res = #False
  
  If *This
    ClearStructure(*This, Visual)
    FreeMemory(*This)
    Res = #True
  EndIf
  
  ProcedureReturn Res
EndProcedure

EndModule
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 87
; FirstLine = 78
; Folding = ---
; EnableUnicode
; EnableXP