﻿DeclareModule Plug
  Declare Create()
EndDeclareModule


Module Plug

UseModule AIMP
UseModule Unknown

Structure Plug Extends UnkSctuct
  *Core.IAIMPCore
  *Visual.IAIMPExtensionCustomVisualization
EndStructure

EnableExplicit

Procedure.s InfoGet(*This.Plug, Index.i)
  Static Res.s
  
  Select Index
    Case #AIMP_PLUGIN_INFO_NAME
      Res = "Тестовый плагин"
    Case #AIMP_PLUGIN_INFO_AUTHOR
      Res = "Пётр"
    Case #AIMP_PLUGIN_INFO_SHORT_DESCRIPTION
      Res = "Плагин визуализации EmbeddedVisualization"
    Case #AIMP_PLUGIN_INFO_FULL_DESCRIPTION
      Res = "Плагин визуализации скомпилированый в PureBasic "+
            InsertString(Str(#PB_Compiler_Version), ".", 2)
  EndSelect
  
  ProcedureReturn Res
EndProcedure

Procedure InfoGetCategories(*This.Plug)
  ProcedureReturn #AIMP_PLUGIN_CATEGORY_VISUALS
EndProcedure

Procedure Initialize(*This.Plug, *Core.IAIMPCore)
  Protected Res = #E_FAIL
  Protected *Visual.IAIMPExtensionCustomVisualization
  
  *This\Core = *Core
  
  *Visual = Visual::Create(*Core)
  If *Visual
    ;Res = *Core\RegisterExtension(AIMP::?IID_IAIMPServiceVisualizations, *Visual)
    Res = *Core\RegisterExtension(?__IID_IAIMPServiceVisualizations, *Visual)
    If Res = #S_NORMAL
      *This\Visual = *Visual
    Else
      Visual::Free(*Visual)
    EndIf
  EndIf
  
  ProcedureReturn Res
  
  DataSection
  __IID_IAIMPServiceVisualizations:
  Data.l $41494D50
  Data.u $5372, $7656
  Data.a $69, $73, $75, $61, $6C, $00, $00, $00
  EndDataSection
  
EndProcedure

Procedure Finalize(*This.Plug)
  If *This\Visual
    Visual::Free(*This\Visual)
    *This\Visual = 0
  EndIf
EndProcedure

Procedure SystemNotification(*This.Plug, NotifyID, *Data.IUnknown)
  
EndProcedure

Procedure Create()
  Protected *Struct.Plug
  
  *Struct = AllocateMemory(SizeOf(Plug))
  If *Struct
    InitializeStructure(*Struct, Plug)
    ;CopyMemory(AIMP::?IID_IUnknown, @*Struct\IID, SizeOf(GUID))
    CopyMemory(?__IID_IUnknown, @*Struct\IID, SizeOf(GUID))
    *Struct\VT = ?Plug
  EndIf
  
  ProcedureReturn *Struct
  
  DataSection
    Plug:
    Unknown::UnkProc
    Data.i @InfoGet()
    Data.i @InfoGetCategories()
    Data.i @Initialize()
    Data.i @Finalize()
    Data.i @SystemNotification()
    
    __IID_IUnknown:
    Data.l $00000000
    Data.u $0000, $0000
    Data.a $C0, $00, $00, $00, $00, $00, $00, $46
  EndDataSection
EndProcedure

EndModule
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 18
; Folding = --
; EnableUnicode
; EnableXP