﻿DeclareModule Spectr

Structure SpectrData
  Arr.f[256]
EndStructure


Declare Init(Width, Height)
Declare Resize(Width, Height)
Declare Free()
Declare Drawing(DC, *Data.SpectrData)
EndDeclareModule

Module Spectr

EnableExplicit

Procedure Draw(Array Infa.f(1))
  Protected i, x.f, StepX.f, StepY.f
  Protected Width, Height, h
  
  If StartDrawing(ImageOutput(0))
    Width = OutputWidth()
    Height = OutputHeight()
    
    StepX = (Width-10) / 18
    StepY = Height / 100
    h = Round(StepX, #PB_Round_Down)
    
    DrawingMode(#PB_2DDrawing_Gradient)

    LinearGradient(0, 0, 0, Height)
    
    BackColor($DFDFDF)
    FrontColor($888888)
    
    Box(0,0, Width, Height, 0)
      
    BackColor($0000FF)
    FrontColor($00FF00)
    
    x=0
    For i=0 To 17
      Box(x, Round(Height-Infa(i)*StepY, #PB_Round_Down), h, Round(Infa(i)*StepY, #PB_Round_Up), 0)
      x+h+1
    Next i
    
    
    StopDrawing()
  EndIf
EndProcedure

Macro ChannelData(Start, Ends, Num)
  For i = Start/2 To Ends/2
    TempF = *Data\Arr[i]
    If Z(Num) < TempF
      Z(Num) = TempF
    EndIf
  Next i
EndMacro


Procedure Drawing(DC, *Data.SpectrData)
  Static Dim Old.f(18)
  Protected Buff.SpectrData
  Protected i, TempF.f, m.f, Temp
  Protected Dim Z.f(18);, 
  
  If IsImage(0)
    
    ChannelData(1, 1, 0) ;13 Hz
    ChannelData(2, 2, 1) ;16 Hz 
    ChannelData(3, 3, 2) ;24 Hz 
    ChannelData(4, 4, 3) ;35 Hz
    ChannelData(5, 7, 4) ;53 Hz
    ChannelData(8, 9, 5) ;79 Hz 
    ChannelData(9, 11, 6);118 Hz 
    ChannelData(12, 15, 7) ;178 Hz 
    ChannelData(16, 23, 8) ;267 Hz
    ChannelData(24, 31, 9) ;400 Hz
    ChannelData(32, 47, 10);600 Hz 
    ChannelData(48, 63, 11);900 Hz
    ChannelData(64, 95, 12);1350 Hz
    ChannelData(96, 127, 13) ;2024 Hz
    ChannelData(128, 191, 14);3036 Hz
    ChannelData(192, 255, 15);4554 Hz
    ChannelData(256, 383, 16);6830 Hz
    ChannelData(384, 512, 17);10250 Hz
    
    
    For i=0 To 17
      Z(i)=Z(i)/100
      Z(i)=100*Pow(Z(i),1/3) ;компрессируем и вычитаем уровень шума
      If Z(i)>100 : Z(i)=100 : EndIf
    Next
    
    
    Draw(z())
    i=StartDrawing(ImageOutput(0))
    If i
      BitBlt_(DC, 0, 0, ImageWidth(0), ImageHeight(0), i, 0, 0, #SRCCOPY)
      StopDrawing()
    EndIf
    
  EndIf
EndProcedure

Procedure Init(Width, Height)
  Protected Res
  
  Res=CreateImage(0, Width, Height, 24)
  
  ProcedureReturn Res
EndProcedure

Procedure Resize(Width, Height)
  If IsImage(0)
    ResizeImage(0, Width, Height, #PB_Image_Raw)
  EndIf
EndProcedure

Procedure Free()
  If IsImage(0)
    FreeImage(0)
  EndIf
EndProcedure

EndModule
; IDE Options = PureBasic 5.31 (Windows - x86)
; Folding = --
; EnableUnicode
; EnableXP