﻿DeclareModule Plug
  Declare Create()
EndDeclareModule


Module Plug

UseModule AIMP
UseModule Unknown

Structure Plug Extends UnkSctuct
  *Core.IAIMPCore
  *Visual.IAIMPExtensionCustomVisualization
EndStructure

EnableExplicit

Procedure RunProgList()
  Static RunOnly = #False
  Protected Path.s
  Protected Prog.s, Param.s, Dir.s
  
  If RunOnly = #False
    RunOnly = #True
    
    Path = GetPathPart(ProgramFilename())
    
    If OpenPreferences(Path+"ProgramList.txt")
      ExaminePreferenceGroups()
      While NextPreferenceGroup()
        
        Prog=ReadPreferenceString("Program", "")
        If Prog
            
          If FileSize(Prog)>0
          ElseIf FileSize(Path+Prog)>0
            Prog = Path + Prog
          Else
            Prog = ""
          EndIf
          
          If Prog
            Param=ReadPreferenceString("Parameter", "")
            Dir=ReadPreferenceString("Directory", "")
            If Param=""
              RunProgram(Prog)
            Else
              RunProgram(Prog, Param, Dir)
            EndIf
          EndIf
          
        EndIf
        
      Wend
      ClosePreferences()
    EndIf
    
  EndIf
  
EndProcedure

Procedure.i InfoGet(*This.Plug, Index.i)
  Protected *Res
    
  Select Index
    Case #AIMP_PLUGIN_INFO_NAME
      *Res = @"VisualShare"
    Case #AIMP_PLUGIN_INFO_AUTHOR
      *Res = @"Пётр (pure-basic@yandex.ru)"
    Case #AIMP_PLUGIN_INFO_SHORT_DESCRIPTION
      *Res = @"Плагин визуализации"
    Case #AIMP_PLUGIN_INFO_FULL_DESCRIPTION
      *Res = @"Плагин визуализации предоставляющий доступ к данным спектра другим программам"
  EndSelect
  
  ProcedureReturn *Res
EndProcedure

Procedure InfoGetCategories(*This.Plug)
  ProcedureReturn #AIMP_PLUGIN_CATEGORY_VISUALS
EndProcedure

Procedure Initialize(*This.Plug, *Core.IAIMPCore)
  Protected Res = #E_FAIL
  Protected *Visual.IAIMPExtensionCustomVisualization
   
  *This\Core = *Core
  
  *Visual = Visual::Create()
  If *Visual
    ;Res = *Core\RegisterExtension(AIMP::?IID_IAIMPServiceVisualizations, *Visual)
    Res = *Core\RegisterExtension(?__IID_IAIMPServiceVisualizations, *Visual)
    If Res = #S_NORMAL
      *This\Visual = *Visual
      Share::Init(#True)
      RunProgList()
    Else
      Visual::Free(*Visual)
    EndIf
  EndIf
  
  ProcedureReturn Res
  
  DataSection
  __IID_IAIMPServiceVisualizations:
  Data.l $41494D50
  Data.u $5372, $7656
  Data.a $69, $73, $75, $61, $6C, $00, $00, $00
  EndDataSection
  
EndProcedure

Procedure Finalize(*This.Plug)
  If *This\Visual
    Visual::Free(*This\Visual)
    *This\Visual = 0
  EndIf
  Share::Free(#True)
EndProcedure

Procedure SystemNotification(*This.Plug, NotifyID, *Data.IUnknown)
  
EndProcedure

Procedure Create()
  Protected *Struct.Plug
  
  *Struct = AllocateMemory(SizeOf(Plug))
  If *Struct
    InitializeStructure(*Struct, Plug)
    ;CopyMemory(AIMP::?IID_IUnknown, @*Struct\IID, SizeOf(GUID))
    CopyMemory(?__IID_IUnknown, @*Struct\IID, SizeOf(GUID))
    *Struct\VT = ?Plug
  EndIf
  
  ProcedureReturn *Struct
  
  DataSection
    Plug:
    Unknown::UnkProc
    Data.i @InfoGet()
    Data.i @InfoGetCategories()
    Data.i @Initialize()
    Data.i @Finalize()
    Data.i @SystemNotification()
    
    
    __IID_IUnknown:
    Data.l $00000000
    Data.u $0000, $0000
    Data.a $C0, $00, $00, $00, $00, $00, $00, $46
    
  EndDataSection
EndProcedure

EndModule
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 89
; FirstLine = 76
; Folding = --
; EnableUnicode
; EnableXP