﻿#AIMP_VISUAL_SPECTRUM_MAX = 256;
#AIMP_VISUAL_WAVEFORM_MAX = 512;

Structure TAIMPVisualDataSpectrum
  Arr.f[#AIMP_VISUAL_SPECTRUM_MAX]
EndStructure

Structure TAIMPVisualDataWaveform
  Arr.f[#AIMP_VISUAL_WAVEFORM_MAX];
EndStructure


Structure TAIMPVisualData
  Peaks.f[2]
  Spectrum.TAIMPVisualDataSpectrum[3]
  WaveForm.TAIMPVisualDataWaveform[2]
  Reserved.i
EndStructure

Structure SpectrData
  Arr.f[256]
EndStructure


EnableExplicit

Procedure Draw(Array Infa.f(1))
  Protected i, x.f, StepX.f, StepY.f
  Protected Width, Height, h
  
  If StartDrawing(CanvasOutput(0))
    Width = OutputWidth()
    Height = OutputHeight()
    
    StepX = (Width-10) / 18
    StepY = Height / 100
    h = Round(StepX, #PB_Round_Down)
    
    DrawingMode(#PB_2DDrawing_Gradient)
    
    LinearGradient(0, 0, 0, Height)
    
    BackColor($DFDFDF)
    FrontColor($888888)
    
    Box(0,0, Width, Height, 0)
    
    BackColor($0000FF)
    FrontColor($00FF00)
    
    x=0
    For i=0 To 17
      Box(x, Round(Height-Infa(i)*StepY, #PB_Round_Down), h, Round(Infa(i)*StepY, #PB_Round_Up), 0)
      x+h+1
    Next i
    
    
    StopDrawing()
  EndIf
EndProcedure

Macro ChannelData(Start, Ends, Num)
  For i = Start/2 To Ends/2
    TempF = *Data\Arr[i]
    If Z(Num) < TempF
      Z(Num) = TempF
    EndIf
  Next i
EndMacro


Procedure Drawing(*Data.SpectrData)
  Static Dim Old.f(18)
  Protected Buff.SpectrData
  Protected i, TempF.f, m.f, Temp
  Protected Dim Z.f(18);, 
    
    ChannelData(0, 1, 0) ;13 Hz
    ChannelData(2, 2, 1) ;16 Hz 
    ChannelData(3, 3, 2) ;24 Hz 
    ChannelData(4, 4, 3) ;35 Hz
    ChannelData(5, 7, 4) ;53 Hz
    ChannelData(8, 9, 5) ;79 Hz 
    ChannelData(9, 11, 6);118 Hz 
    ChannelData(12, 15, 7) ;178 Hz 
    ChannelData(16, 23, 8) ;267 Hz
    ChannelData(24, 31, 9) ;400 Hz
    ChannelData(32, 47, 10);600 Hz 
    ChannelData(48, 63, 11);900 Hz
    ChannelData(64, 95, 12);1350 Hz
    ChannelData(96, 127, 13) ;2024 Hz
    ChannelData(128, 191, 14);3036 Hz
    ChannelData(192, 255, 15);4554 Hz
    ChannelData(256, 383, 16);6830 Hz
    ChannelData(384, 511, 17);10250 Hz
    
    
    For i=0 To 17
      Z(i)=Z(i)/100
      Z(i)=100*Pow(Z(i),1/3) ;компрессируем и вычитаем уровень шума
      If Z(i)>100 : Z(i)=100 : EndIf
    Next
    
    Draw(z())
EndProcedure

Procedure CB(*Data.TAIMPVisualData)
  Drawing(@*Data\Spectrum[2]\Arr[0])
EndProcedure

Procedure Timer()
  If CallFunction(0, "IsAimp")
    SetGadgetText(2, "Плагин работает")
  Else
    SetGadgetText(2, "Плагин не активен")
  EndIf
EndProcedure

OpenWindow(0, 0, 0, 200, 100, "Плагин AIMP",#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered)
TextGadget(2,10,10,180,16,"")
CanvasGadget(0, 10, 28, 180, 64, 0)

If OpenLibrary(0, "VisualShare.dll")
  CallFunction(0, "LibInit")
  CallFunction(0, "SetCallBack", @CB(), #True)
Else
  MessageRequester("", "Не удалось загрузить библиотеку")
  End
EndIf

Timer()
AddWindowTimer(0,0,1000)
BindEvent(#PB_Event_Timer, @Timer(), 0, 0)

Repeat
  
  
  
Until WaitWindowEvent()=#PB_Event_CloseWindow

CallFunction(0, "LibFree")
CloseLibrary(0)

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 140
; FirstLine = 101
; Folding = -
; EnableUnicode
; EnableThread
; Executable = Окно.exe